package model

import (
	"context"
	"fmt"
	"gitlab.okta-solutions.com/mashroom/backend/common/generic/env"
	"go.mongodb.org/mongo-driver/mongo"
	"go.mongodb.org/mongo-driver/mongo/options"
	"time"
)

var (
	MongoUrl      = env.ResolveString("MONGO_URL", "mongodb:27017")
	MongoDb       = env.ResolveString("MONGO_DATABASE", "maintenance-data")
	MongoUsername = env.ResolveString("MONGO_USERNAME", "maintenance-data")
	MongoPassword = env.ResolveString("MONGO_PASSWORD", "maintenance-data")
)

const (
	MongoMaintenanceCollection = "maintenance"
)

var Client *mongo.Client
var DB *mongo.Database

var Maintenances *mongo.Collection

func init() {
	if c, err := mongo.NewClient(options.Client().ApplyURI(fmt.Sprintf("mongodb://%s", MongoUrl)).SetAuth(options.Credential{
		AuthSource:  "admin",
		Username:    MongoUsername,
		Password:    MongoPassword,
		PasswordSet: true,
	})); err != nil {
		panic(err)
	} else {
		Client = c
	}
	ctx, _ := context.WithTimeout(context.Background(), 10*time.Second)
	if err := Client.Connect(ctx); err != nil {
		panic(err)
	}

	DB = Client.Database(MongoDb)
	Maintenances = DB.Collection(MongoMaintenanceCollection)
}
